
/* file        : sha.c
 * created     : Thu Oct 16 15:13:19 MET DST 1997
 *
 * description : the SHA-1 message digest algorithm (Handbook Alg. 9.53) 
 * author      : Damian Weber
 */

#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <string.h>

#include "sha.h"   

#define SECRET "\x00\x01\x02\x03\x04\x05\x06\x07\x08\x09\x0a\x0b\x0c\x0d\x0e\x0f"
#define SECRET_LENGTH 15


int main(int argc, char **argv)
    {
    char digest[160];
    int j;
    int r;

    if (argc<=1) 
    {
       printf("usage %s <string1> [string2] ... \n",argv[0]);
       return 1;
    }


    for (r=1;r<argc;r++)
    {
       sha(argv[r], (WORD) strlen(argv[r]), digest);
       printf("SHA-1('%s')=",argv[r]); 
       for (j=0;j<20;j++)
	  printf("%02x",(unsigned int) digest[j] & 0xff);
       printf("\n");

       sha_hmac_kxk(SECRET,SECRET_LENGTH,argv[r], (WORD) strlen(argv[r]), digest);
       printf("SHA-1-HMAC('%s')=",argv[r]); 
       for (j=0;j<20;j++)
	  printf("%02x",(unsigned int) digest[j] & 0xff);
       printf("\n");
    }

    return 0;
    }
